# include "std.h"
# if LICENCE
   This file is part of cwrite.
   Copyright 2007, Desislav Georgiev.
 
   cwrite is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
 
   cwrite is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with cwrite.  If not, see <http://www.gnu.org/licenses/>.
# endif
# if HEADER
   # include <stdio.h>
   # include <stdlib.h>
   # include <unistd.h>
   # include <fcntl.h>
   # include <dirent.h>

   # include "failure.h"
   # include "message.h"
# endif

ssize_t io_read(int fd, void * _buf, size_t count)
   { int sid = 106;

     int r = read(fd, _buf, count);
     if ( r == -1 )
        { fail(sid, _message[50]);
        }
     return r;
   }
ssize_t io_write(int fd, const void * _buf, size_t count)
   { int sid = 107;

     int r = write(fd, _buf, count);
     if ( r == -1 )
        { fail(sid, _message[50]);
        }
     return r;
   }

off_t io_lseek(int fd, off_t offset, int whence)
   { int sid = 108;

     int r = lseek(fd, offset, whence);
     if ( r == -1 )
        { fail(sid, _message[50]);
        }
     return r;
   }

int io_close(int fd)
   { int sid = 109;

     int r = close(fd);
     if ( r == -1 )
        { fail(sid, _message[50]);
        }
     return r;
   }

int io_open(const char * _pathname, int flags)
   { int sid = 110;

     int r = open(_pathname, flags);
     if ( r == -1 )
        { fail(sid, _message[50]);
        }
     return r;
   }
int io_creat(const char * _pathname, mode_t mode)
   { int sid = 111;

     int r = creat(_pathname, mode);
     if ( r == -1 )
        { fail(sid, _message[50]);
        }
     return r;
   }

int io_closedir (DIR * _dirstream)
   { int sid = 116;

     int r = closedir(_dirstream);
     if ( r == -1 )
        { fail(sid, _message[50]);
        }
     return r;
   }

