# include "std.h"
# if LICENCE
   This file is part of cwrite.
   Copyright 2007, Desislav Georgiev.
 
   cwrite is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
 
   cwrite is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with cwrite.  If not, see <http://www.gnu.org/licenses/>.
# endif
# if HEADER
   # include <stdio.h>
   # include <stdlib.h>
   # include <unistd.h>
   # include <fcntl.h>

   # include "cwrite.h"
   # include "failure.h"
   # include "io.h"
   # include "message.h"
   # include "preferences.h"
# endif
# if GLOBAL
   Preferences * _preferences;
   int tab_limit = 20;
# endif

void preferences_init()
   { _preferences = (Preferences *) calloc(1, sizeof(Preferences));
     _preferences->color_theme = 1;
     _preferences->tab_value = 3;
     _preferences->syntax = SYNTAX_C;
     _preferences->line_feed = LF_SMART;
     return;
   }
void preferences_save()
   { int sid = 105;

     int fd = open(_user_preferences, O_WRONLY | O_CREAT | O_TRUNC, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);
     if ( fd == -1 )
        { fail(sid, _message[58]);
        }
     int preferences_size = sizeof(Preferences);
     io_write(fd, & preferences_size, sizeof(preferences_size));
     io_write(fd, _preferences, preferences_size);
     io_close(fd);
     return;
   }
void preferences_load()
   { int fd = open(_user_preferences, O_RDONLY);
     if ( fd == -1 )
        { return;
        }
     int preferences_size;
     int file_size = io_lseek(fd, 0, SEEK_END);
     if ( file_size < sizeof(preferences_size) )
        { io_close(fd);
          return;
        }
     io_lseek(fd, 0, SEEK_SET);
     io_read(fd, & preferences_size, sizeof(preferences_size));
     if ( preferences_size != sizeof(Preferences) )
        { io_close(fd);
          return;
        }
     if ( preferences_size + sizeof(preferences_size) != file_size )
        { io_close(fd);
          return;
        }
     io_read(fd, _preferences, sizeof(Preferences));
     io_close(fd);
     return;
   }

